import http from './http.js'

const config = {
	// 示例
	// wxLogin : {url : '/api/wxLogin', method : 'POST', 
	// auth : false, showLoading : true, loadingTitle : '加载中...',
	// limit : 1000
	// },
	
	getConfig : {url : '/api/getConfig', method : 'GET', limit : 500},
	
	//获取banner列表
	indexGetBanner : {url : '/api/index/getBanner', method : 'GET'},
	//获取认证演员
	indexGetActorList : {url : '/api/index/getActorList', method : 'GET'},
	//获取动态列表带分页
	indexGetTrendsPage : {url : '/api/index/getTrendsPage', method : 'GET'},
	//获取动态列表带分页
	indexGetActorSetPage : {url : '/api/index/getActorSetPage', method : 'GET'},
	//获取动态详情
	indexGetTrendsDetail : {url : '/api/index/getTrendsDetail', method : 'GET'},
}



export function api(key, data, callback, loadingTitle){
	let req = config[key]
	
	if (!req) {
		console.error('无效key' + key);
		return
	}
	
	if(typeof callback == 'string'){
		loadingTitle = callback
	}
	
	if(typeof data == 'function'){
		callback = data
		data = {}
	}
	
	// 接口限流
	if(req.limit){
		let storageKey = 'limit:' + req.url
		let storage = uni.getStorageSync(storageKey)
		if(storage && new Date().getTime() - parseInt(storage) < req.limit){
			return
		}
		uni.setStorageSync(storageKey, new Date().getTime())
	}
	
	//必须登录
	if (req.auth) {
		if (!uni.getStorageSync('token')) {
			uni.navigateTo({
				url: '/pages/auth/login'
			})
			console.error('需要登录')
			return
		}
	}
	
	http.http(req.url, data, callback, req.method, 
	loadingTitle || req.showLoading, loadingTitle || req.loadingTitle)
}



export default api